SystemOrganization addCategory: #ConfigurationOfAthensSVG!

Object subclass: #ConfigurationOfAthensSVG
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAthensSVG'!

!ConfigurationOfAthensSVG commentStamp: 'StephaneDucasse 12/6/2014 07:59' prior: 0!
(ConfigurationOfAthensSVG project version: '1.0' ) load

In the future we should separate the SVG parser and document builder from the Athens part.!

!ConfigurationOfAthensSVG class methodsFor: 'private' stamp: ''!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfAthensSVG class methodsFor: 'private' stamp: ''!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk globals at: #MetacelloProject ifAbsent: [
		Smalltalk globals at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk globals at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfAthensSVG class methodsFor: 'metacello tool support' stamp: ''!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAthensSVG class methodsFor: 'metacello tool support' stamp: ''!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfAthensSVG class methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 1/31/2013 18:05'!
loadStable

	(self project project version: #stable) load! !

!ConfigurationOfAthensSVG class methodsFor: 'metacello tool support' stamp: ''!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfAthensSVG class methodsFor: 'accessing' stamp: ''!
project

	^self new project! !

!ConfigurationOfAthensSVG methodsFor: 'baselines' stamp: 'StephaneDucasse 12/6/2014 08:00'!
baseline10: spec 
	<version: '1.0-baseline'>

	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://smalltalkhub.com/mc/Pharo/Athens/main'.
		spec project: 'XMLParser' with: [
				spec
					className: 'ConfigurationOfXMLParser';
					versionString: '1.8.7' ;
					repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLParser/main' ].
		"later we can introduce Athens dependency but the configuration would have to be in the image."
		spec package: 'Athens-SVG' with: [ spec requires: 'XMLParser' ].
		].! !

!ConfigurationOfAthensSVG methodsFor: 'symbolic' stamp: 'NicolaiHess 4/28/2015 17:06'!
development: spec
	<symbolicVersion: #development>
	
	spec for: #common version: '1.0-baseline'! !

!ConfigurationOfAthensSVG methodsFor: 'accessing' stamp: ''!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk globals at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfAthensSVG methodsFor: 'versions' stamp: 'StephaneDucasse 12/6/2014 07:45'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #pharo do: [
		spec blessing: #release.
		spec author: 'StephaneDucasse'.
		spec description: 'First version of this configuration'.		
		spec 
			package: 'Athens-SVG' with: 'Athens-SVG-StephaneDucasse.12'
			
		].
	! !

!ConfigurationOfAthensSVG methodsFor: 'versions' stamp: 'NicolaiHess 4/28/2015 16:52'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'NicolaiHess'.
		spec package: 'Athens-SVG' with: 'Athens-SVG-NicolaiHess.13'
			
		].
	! !

!ConfigurationOfAthensSVG methodsFor: 'versions' stamp: 'AliakseiSyrel 3/28/2016 18:45'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'TudorGirba'.
		spec package: 'Athens-SVG' with: 'Athens-SVG-AliakseiSyrel.16'
			
		].
	! !
